public class Sweep {
	SqrOsc osc;
  0.05 => osc.gain;
  69 + 3 * 12 => Std.mtof => osc.freq;

  false => int stop;

  0 => float s;
  10000 => float end;

  (s - end => Math.fabs)::ms => dur duration;

  fun void set() {
	  while (osc.freq() < end) {
	    osc.freq() + 1 => osc.freq;
	    1::ms => now;
	  }
	  while (osc.freq() > end) {
	    osc.freq() - 1 => osc.freq;
	    1::ms => now;
	  }
  }

  fun void start() {
    false => stop;
    osc => dac;
    while (!stop) {
			s => osc.freq;
			spork ~ set();
			duration => now;
		  Math.random2f(20, 20000) => s;
		  Math.random2f(20, 20000) => end;
		  (s - end => Math.fabs)::ms => duration;
    }
    osc =< dac;
  }
}
