public class Moon extends GGen {
	-50 => posZ;

	GPointLight l --> GSphere s --> this;
	2 => l.intensity;
	(0., 0.) => l.falloff;

	@(2.5, 2.5, 2.5) => s.sca;

	FlatMaterial m;
	@(246. / 255., 241. / 255., 213. / 255.) => m.color;
	m => s.mat;

//	FileTexture t;
//  "assets/moon.jpg" => t.path;
//
//  t => s.mat().diffuseMap;

	false => int freeze;

	time start;

	fun void update(float dt) {
		0.05 * dt => rotX;
		0.1 * dt => rotY;

		if (freeze) return;

		if (start / second == 0) now => start;

		20 * ((now - start) / second * 0.1 + 3 * Math.PI / 2 => Math.cos) => posX;
		20 * ((now - start) / second * 0.1 + 3 * Math.PI / 2 => Math.sin) => posY;

		(1 + ((now - start) / second * 0.1 + 3 * Math.PI / 2 => Math.sin)) / 3 => l.intensity;
	}
}
