public class Sun extends GGen {
	0.1 => GG.scene().light().intensity;

	-50 => posZ;

	GPointLight l --> GSphere s --> this;
	2 => l.intensity;
	(0., 0.) => l.falloff;

	@(5, 5, 5) => s.sca;

	FlatMaterial m;
	@(254. / 255., 197. / 255., 112. / 255.) => m.color;
	m => s.mat;

//	FileTexture t;
//  "assets/sun.jpg" => t.path;
//
//  t => mat().diffuseMap;

	false => int freeze;

	time start;

	fun void update(float dt) {
		if (freeze) return;

		if (start / second == 0) now => start;

		30 * ((now - start) / second * 0.1 + Math.PI / 2 => Math.cos) => posX;
		30 * ((now - start) / second * 0.1 + Math.PI / 2 => Math.sin) => posY;

		1 + ((now - start) / second * 0.1 + Math.PI / 2 => Math.sin) => l.intensity;
	}
}
